
_Display_Init:
	LNK	#18

;Stretch.mpas,47 :: 		begin
;Stretch.mpas,48 :: 		TFT_BLED_Direction := 0;             // Set TFT backlight pin as output
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	BCLR	TRISD2_bit, BitPos(TRISD2_bit+0)
;Stretch.mpas,49 :: 		TFT_Set_Default_Mode();
	CALL	_TFT_Set_Default_Mode
;Stretch.mpas,50 :: 		TFT_Init_ILI9481_8bit(320, 240);     // Initialize TFT display
	MOV	#240, W11
	MOV	#320, W10
	CALL	_TFT_Init_ILI9481_8bit
;Stretch.mpas,51 :: 		TFT_BLED := 1;                       // Turn on TFT backlight
	BSET	LATD2_bit, BitPos(LATD2_bit+0)
;Stretch.mpas,52 :: 		TFT_Fill_Screen(CL_WHITE);
	MOV	#65535, W10
	CALL	_TFT_Fill_Screen
;Stretch.mpas,53 :: 		TFT_Set_Pen(CL_BLACK, 1);
	MOV	#1, W11
	CLR	W10
	CALL	_TFT_Set_Pen
;Stretch.mpas,54 :: 		TFT_Line(20, 220, 300, 220);
	MOV	#220, W13
	MOV	#300, W12
	MOV	#220, W11
	MOV	#20, W10
	CALL	_TFT_Line
;Stretch.mpas,55 :: 		TFT_LIne(20,  46, 300,  46);
	MOV	#46, W13
	MOV	#300, W12
	MOV	#46, W11
	MOV	#20, W10
	CALL	_TFT_Line
;Stretch.mpas,56 :: 		TFT_Set_Font(@TFT_defaultFont, CL_RED, FO_HORIZONTAL);
	CLR	W13
	MOV	#63488, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mpas,57 :: 		TFT_Write_Text('Stretch  Click', 25, 14);
	ADD	W14, #0, W1
	MOV.B	#83, W0
	MOV.B	W0, [W1++]
	MOV.B	#116, W0
	MOV.B	W0, [W1++]
	MOV.B	#114, W0
	MOV.B	W0, [W1++]
	MOV.B	#101, W0
	MOV.B	W0, [W1++]
	MOV.B	#116, W0
	MOV.B	W0, [W1++]
	MOV.B	#99, W0
	MOV.B	W0, [W1++]
	MOV.B	#104, W0
	MOV.B	W0, [W1++]
	MOV.B	#32, W0
	MOV.B	W0, [W1++]
	MOV.B	#32, W0
	MOV.B	W0, [W1++]
	MOV.B	#67, W0
	MOV.B	W0, [W1++]
	MOV.B	#108, W0
	MOV.B	W0, [W1++]
	MOV.B	#105, W0
	MOV.B	W0, [W1++]
	MOV.B	#99, W0
	MOV.B	W0, [W1++]
	MOV.B	#107, W0
	MOV.B	W0, [W1++]
	CLR	W0
	MOV.B	W0, [W1++]
	ADD	W14, #0, W0
	MOV	#14, W12
	MOV	#25, W11
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Stretch.mpas,58 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
	CLR	W13
	CLR	W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mpas,59 :: 		TFT_Write_Text('EasyPIC Fusion v7', 19, 223);
	ADD	W14, #0, W1
	MOV.B	#69, W0
	MOV.B	W0, [W1++]
	MOV.B	#97, W0
	MOV.B	W0, [W1++]
	MOV.B	#115, W0
	MOV.B	W0, [W1++]
	MOV.B	#121, W0
	MOV.B	W0, [W1++]
	MOV.B	#80, W0
	MOV.B	W0, [W1++]
	MOV.B	#73, W0
	MOV.B	W0, [W1++]
	MOV.B	#67, W0
	MOV.B	W0, [W1++]
	MOV.B	#32, W0
	MOV.B	W0, [W1++]
	MOV.B	#70, W0
	MOV.B	W0, [W1++]
	MOV.B	#117, W0
	MOV.B	W0, [W1++]
	MOV.B	#115, W0
	MOV.B	W0, [W1++]
	MOV.B	#105, W0
	MOV.B	W0, [W1++]
	MOV.B	#111, W0
	MOV.B	W0, [W1++]
	MOV.B	#110, W0
	MOV.B	W0, [W1++]
	MOV.B	#32, W0
	MOV.B	W0, [W1++]
	MOV.B	#118, W0
	MOV.B	W0, [W1++]
	MOV.B	#55, W0
	MOV.B	W0, [W1++]
	CLR	W0
	MOV.B	W0, [W1++]
	ADD	W14, #0, W0
	MOV	#223, W12
	MOV	#19, W11
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Stretch.mpas,60 :: 		TFT_Set_Font(@TFT_defaultFont, CL_RED, FO_HORIZONTAL);
	CLR	W13
	MOV	#63488, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mpas,61 :: 		TFT_Write_Text('www.mikroe.com', 200, 223);
	ADD	W14, #0, W1
	MOV.B	#119, W0
	MOV.B	W0, [W1++]
	MOV.B	#119, W0
	MOV.B	W0, [W1++]
	MOV.B	#119, W0
	MOV.B	W0, [W1++]
	MOV.B	#46, W0
	MOV.B	W0, [W1++]
	MOV.B	#109, W0
	MOV.B	W0, [W1++]
	MOV.B	#105, W0
	MOV.B	W0, [W1++]
	MOV.B	#107, W0
	MOV.B	W0, [W1++]
	MOV.B	#114, W0
	MOV.B	W0, [W1++]
	MOV.B	#111, W0
	MOV.B	W0, [W1++]
	MOV.B	#101, W0
	MOV.B	W0, [W1++]
	MOV.B	#46, W0
	MOV.B	W0, [W1++]
	MOV.B	#99, W0
	MOV.B	W0, [W1++]
	MOV.B	#111, W0
	MOV.B	W0, [W1++]
	MOV.B	#109, W0
	MOV.B	W0, [W1++]
	CLR	W0
	MOV.B	W0, [W1++]
	ADD	W14, #0, W0
	MOV	#223, W12
	MOV	#200, W11
	MOV	W0, W10
	CALL	_TFT_Write_Text
;Stretch.mpas,62 :: 		end;
L_end_Display_Init:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
	ULNK
	RETURN
; end of _Display_Init

_readSensor:

;Stretch.mpas,69 :: 		begin
;Stretch.mpas,70 :: 		adc_rd := ADC1_Get_Sample(8);              // Get ADC value from corresponding channel
	PUSH	W10
	MOV	#8, W10
	CALL	_ADC1_Get_Sample
	MOV	W0, _adc_rd
;Stretch.mpas,71 :: 		delay_ms(10);                              // Pause 10ms
	MOV	#13333, W7
L__readSensor2:
	DEC	W7
	BRA NZ	L__readSensor2
	NOP
;Stretch.mpas,72 :: 		end;
L_end_readSensor:
	POP	W10
	RETURN
; end of _readSensor

_set_adc:

;Stretch.mpas,79 :: 		begin
;Stretch.mpas,80 :: 		AD1PCFGL := 0xFFEF;          // Set RA8 as input
	MOV	#65519, W0
	MOV	WREG, AD1PCFGL
;Stretch.mpas,81 :: 		AD1PCFGH := 0xFFFF;          // All other pins are digital
	MOV	#65535, W0
	MOV	WREG, AD1PCFGH
;Stretch.mpas,82 :: 		ADC1_Init();                // Initialize ADC
	CALL	_ADC1_Init
;Stretch.mpas,83 :: 		Delay_ms(100);
	MOV	#3, W8
	MOV	#2261, W7
L__set_adc5:
	DEC	W7
	BRA NZ	L__set_adc5
	DEC	W8
	BRA NZ	L__set_adc5
;Stretch.mpas,84 :: 		end;
L_end_set_adc:
	RETURN
; end of _set_adc

_main:
	MOV	#2048, W15
	MOV	#6142, W0
	MOV	WREG, 32
	MOV	#1, W0
	MOV	WREG, 52
	MOV	#4, W0
	IOR	68

;Stretch.mpas,86 :: 		begin
;Stretch.mpas,87 :: 		set_adc();                                                         // Set A/D register
	PUSH	W10
	PUSH	W11
	PUSH	W12
	PUSH	W13
	CALL	_set_adc
;Stretch.mpas,88 :: 		Display_Init();                                                    // Initialize TFT
	CALL	_Display_Init
;Stretch.mpas,89 :: 		TFT_Set_Pen(CL_WHITE, 1);
	MOV	#1, W11
	MOV	#65535, W10
	CALL	_TFT_Set_Pen
;Stretch.mpas,90 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);
	CLR	W13
	CLR	W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mpas,91 :: 		while TRUE do
L__main9:
;Stretch.mpas,93 :: 		readSensor();                                                  // Read sensor
	CALL	_readSensor
;Stretch.mpas,94 :: 		TFT_Set_Font(@TFT_defaultFont, CL_WHITE, FO_HORIZONTAL);
	CLR	W13
	MOV	#65535, W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mpas,95 :: 		TFT_Write_Text(txt, 140, 100);
	MOV	#100, W12
	MOV	#140, W11
	MOV	#lo_addr(_txt), W10
	CALL	_TFT_Write_Text
;Stretch.mpas,96 :: 		WordToStr(adc_rd,txt);                                        // Conversion integer adc_rd to string txt
	MOV	#lo_addr(_txt), W11
	MOV	_adc_rd, W10
	CALL	_WordToStr
;Stretch.mpas,97 :: 		TFT_Set_Font(@TFT_defaultFont, CL_BLACK, FO_HORIZONTAL);       // Display string on TFT
	CLR	W13
	CLR	W12
	MOV	#lo_addr(_TFT_defaultFont), W10
	MOV	#higher_addr(_TFT_defaultFont), W11
	CALL	_TFT_Set_Font
;Stretch.mpas,98 :: 		TFT_Write_Text(txt,140,100);                                   // Print txt value on TFT
	MOV	#100, W12
	MOV	#140, W11
	MOV	#lo_addr(_txt), W10
	CALL	_TFT_Write_Text
;Stretch.mpas,99 :: 		delay_ms(500);
	MOV	#11, W8
	MOV	#11309, W7
L__main13:
	DEC	W7
	BRA NZ	L__main13
	DEC	W8
	BRA NZ	L__main13
;Stretch.mpas,100 :: 		end;
	GOTO	L__main9
;Stretch.mpas,101 :: 		end.
L_end_main:
	POP	W13
	POP	W12
	POP	W11
	POP	W10
L__main_end_loop:
	BRA	L__main_end_loop
; end of _main
